<?php

namespace Modules\User\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\UserRoleEnum;

class UserRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('users'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $roles = UserRoleEnum::admins();
        $rules =
        [
            'name'=>
            [
                'required',
                'string'
            ],
            'email'=>
            [
                'required',
                'email',
                Rule::unique('users','email')->ignore($this->user ?? null)
            ],
            'phone'=>
            [
                'required',
                'numeric',
                'regex:/^9665\d{8}$/',
                Rule::unique('users','phone')->ignore($this->user ?? null)
            ],
            'photo'=>
            [
                'nullable'
            ],
            'role'=>
            [
                'required',
                'in:'.implode(',',$roles)
            ],
            'password'=>
            [
                $this->user ? 'sometimes' : 'required',
                'confirmed'
            ],
            'modules'=>
            [
                'required',
                'array',
                Rule::exists('modules', 'id')->whereNull('deleted_at'),
            ]
        ];


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'name'=>__('users.name'),
            'email'=>__('users.email'),
            'phone'=>__('users.phone'),
            'photo'=>__('users.photo'),
            'role'=>__('users.role'),
            'password'=>__('users.password'),
            'password_confirmation'=>__('users.password_confirmation'),

        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
